#!/usr/bin/perl
#
# Rubi's Ultimate Backup Implementation
#
# Version 2.0, (C) 3.1999 by Beat Rubischon <beat@rubis.ch>
#                  8.1999 by Beat Rubischon <beat.rubischon@trivadis.com>
#                  2.2000 by Beat Rubischon <beat@rubis.ch>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# This script walks through a directory tree like "find $basedir -mount"
# additional information from stat() is printed.
#
# it expects one or more directories as starting point

foreach(@ARGV) {
  ($basedev)=stat($_);
  dirwalk($_);
}

sub dirwalk {
  my $curdir=$_[0];
  opendir(DIR, $curdir);
  my @files=readdir(DIR);
  closedir(DIR);

  foreach(@files) {
    if ($_ ne "." and $_ ne "..") {
      $file=$curdir."/".$_;
      ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks)=lstat($file);
      $type=substr((sprintf "%06o", $mode), 0, 2);

      print "$type,$dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks,$file\n";

      if ($type eq "04" and $dev eq $basedev) {
        dirwalk($file);
      }
    }
  }
}
